// $Id: Datatypes.h 18 2014-06-16 11:59:04Z dettus $
/*
Copyright (c) 2014, Thomas Dettbarn (dettus@dettus.net)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/


#ifndef	DATATYPES_H
#define	DATATYPES_H
#include "Config.h"

typedef	unsigned char		tUInt8;
typedef	unsigned short		tUInt16;
typedef	unsigned int		tUInt32;
typedef	unsigned long long	tUInt64;

typedef	signed char		tInt8;
typedef	signed short		tInt16;
typedef	signed int		tInt32;
typedef	signed long long	tInt64;


typedef	struct	_tColors
{
	tInt32	fg;
	tInt32	bg;
	tInt32	attr;
	tInt32	combined_attributes;
} tColors;

typedef	enum _tColRoles
{
	COL_TILE_2=1,
	COL_TILE_4,
	COL_TILE_8,
	COL_TILE_16,
	COL_TILE_32,
	COL_TILE_64,
	COL_TILE_128,
	COL_TILE_256,
	COL_TILE_512,
	COL_TILE_1024,
	COL_TILE_2048,
	COL_TILE_SPACE,

	COL_FRAME,
	COL_HUD,


	COL_LAST_ENTRY
} tColRoles;

typedef struct	_tField
{
	tInt16	tile[TILE_ROWS][TILE_COLS];
} tField;

typedef	struct	_tHandle
{
	WINDOW* 	win;
	tColors		colors[COL_LAST_ENTRY];
	tField		actField;
	int score;
	int best;
} tHandle;


#endif
