// $Id: Main.c 18 2014-06-16 11:59:04Z dettus $

/*
Copyright (c) 2014, Thomas Dettbarn (dettus@dettus.net)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include "Datatypes.h"
#include "Output.h"
#include "Move.h"
#include "Version.h"
#include  <time.h>

int main(void)
{
	tHandle	handle;
	tInt16	ch;
	int	quit=0;
	int	leave;

	handle.best=0;
	handle.win=NULL;
	srand(time(NULL));
	while (!quit)
	{

		initOutput(&handle);
	

		initField(&handle);
		drawField(&handle);
		newTile(&handle);	
		newTile(&handle);


		ch=0;
		leave=0;
		while (!leave)
		{	
			int m;
			drawField(&handle);
			ch=getch();
			m=0;
			switch(ch)
			{
				case KEY_UP:
				case 'K':
				case 'k':
				case 'W':
				case 'w':	m=makeMove(&handle,MOVE_UP);break;

				case KEY_DOWN:
				case 'J':
				case 'j':
				case 'S':
				case 's':	m=makeMove(&handle,MOVE_DOWN);break;

				case KEY_LEFT:
				case 'H':
				case 'h':
				case 'A':
				case 'a':	m=makeMove(&handle,MOVE_LEFT);break;

				case KEY_RIGHT:
				case 'L':
				case 'l':
				case 'D':
				case 'd':	m=makeMove(&handle,MOVE_RIGHT);break;
			}
			if (m)
			{
				newTile(&handle);
				if (m==WINNING_TILE)
				{
					leave=1;
					drawField(&handle);
					quit=winner(&handle);
				}
			}
			m=checkMoveable(&handle);
			if (!m)
			{
				leave=1;
				drawField(&handle);
				quit=loser(&handle);
			}
			if (ch=='Q') leave=quit=1;
		}

	}
	endOutput(&handle);

	printf("[n2048 v%i.%i] Copyright (c) 2014, Thomas Dettbarn (dettus@dettus.net)\n",MAJOR_REVISION,MINOR_REVISION);
	printf("All rights reserved.\n");
	printf("\n");
	printf("Redistribution and use in source and binary forms, with or without\n");
	printf("modification, are permitted provided that the following conditions are met:\n");
	printf("\n");
	printf("1. Redistributions of source code must retain the above copyright notice, this\n");
	printf("   list of conditions and the following disclaimer. \n");
	printf("2. Redistributions in binary form must reproduce the above copyright notice,\n");
	printf("   this list of conditions and the following disclaimer in the documentation\n");
	printf("   and/or other materials provided with the distribution.\n");
	printf("\n");
	printf("THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND\n");
	printf("ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n");
	printf("WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n");
	printf("DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR\n");
	printf("ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n");
	printf("(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n");
	printf("LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n");
	printf("ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n");
	printf("(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n");
	printf("SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n");
	printf("\n");
}
